=== debian/changelog ===
ktexteditor (5.92.0-0ubuntu1) jammy; urgency=medium

  * New upstream release (5.92.0)
  * Update symbols

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Wed, 16 Mar 2022 16:28:47 +0000

ktexteditor (5.91.0-0ubuntu1) jammy; urgency=medium

  * New upstream release (5.91.0)
  * Delete 0001-Revert-Do-not-cancel-mouse-selection-when-using-the-.patch,
    applied upstream.
  * Update installed files
  * Update symbols

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Mon, 14 Feb 2022 17:09:59 +0000

ktexteditor (5.90.0-0ubuntu2) jammy; urgency=medium

  * Fix marking of text (LP: #1958090)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Sun, 16 Jan 2022 23:52:21 +0100

ktexteditor (5.90.0-0ubuntu1) jammy; urgency=medium

  * New upstream release (5.90.0)
  * Update symbols.
  * Update install files.

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Jan 2022 16:49:02 +0000

ktexteditor (5.89.0-0ubuntu1) jammy; urgency=medium

  * New upstream release (5.89.0)
  * Update symbols

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Sun, 12 Dec 2021 15:17:45 +0000

ktexteditor (5.88.0-1ubuntu3) jammy; urgency=medium

  * Add Kubuntu Vcs fields.

 -- Rik Mills <rikmills@kde.org>  Sun, 28 Nov 2021 18:12:11 +0000

ktexteditor (5.88.0-1ubuntu2) jammy; urgency=medium

  * Update lintian overrides.

 -- Rik Mills <rikmills@kde.org>  Sat, 27 Nov 2021 10:35:57 +0000

ktexteditor (5.88.0-1ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Do not run tests at build time.
    - Keep our symbols file.
    - Update lintian overrides.

 -- Rik Mills <rikmills@kde.org>  Fri, 26 Nov 2021 07:21:39 +0000

ktexteditor (5.88.0-1) unstable; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.87.0).
  * Update symbols (Closes: #997102).
  * New upstream release (5.88.0).
  * Update symbols.
  * Force-bump frameworks internal b-d to 5.88.

 -- Norbert Preining <norbert@preining.info>  Wed, 17 Nov 2021 06:07:41 +0900

ktexteditor (5.88.0-0ubuntu1) jammy; urgency=medium

  * New upstream release (5.88.0)
  * Update symbols.

 -- Rik Mills <rikmills@kde.org>  Sat, 13 Nov 2021 18:20:32 +0000

ktexteditor (5.87.0-0ubuntu1) jammy; urgency=medium

  * New upstream release (5.87.0)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Thu, 11 Nov 2021 11:07:22 +0000

ktexteditor (5.86.0-1) unstable; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.86.0).
  * Update symbols.

 -- Norbert Preining <norbert@preining.info>  Mon, 13 Sep 2021 15:02:47 +0900

ktexteditor (5.85.0-3) unstable; urgency=medium

  * Team upload.

  [ Norbert Preining ]
  * Really disable BLHC of Salsa CI.

  [ Pino Toscano ]
  * Bump Standards-Version to 4.6.0, no changes required.
  * Update symbols file.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Mon, 30 Aug 2021 19:10:19 +0200

ktexteditor (5.85.0-2) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Sat, 28 Aug 2021 23:42:48 +0900

ktexteditor (5.85.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.85.0).
  * Update symbols.

 -- Norbert Preining <norbert@preining.info>  Mon, 16 Aug 2021 00:05:48 +0900

ktexteditor (5.83.0-3) unstable; urgency=medium

  * Upload to unstable.

 -- Norbert Preining <norbert@preining.info>  Mon, 16 Aug 2021 11:53:10 +0900

ktexteditor (5.83.0-2) experimental; urgency=medium

  [ Norbert Preining ]
  * Fix symbols for 32bit archs.

 -- Norbert Preining <norbert@preining.info>  Mon, 14 Jun 2021 13:30:05 +0900

ktexteditor (5.83.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.83.0).
  * Update symbols.

 -- Norbert Preining <norbert@preining.info>  Sun, 13 Jun 2021 12:48:22 +0900

ktexteditor (5.82.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.82.0).
  * Removed Maximiliano Curia from the uploaders, thanks for your work
    on the package!
  * Update symbols (some not exported ones are dropped).

 -- Norbert Preining <norbert@preining.info>  Sun, 09 May 2021 10:55:18 +0900

ktexteditor (5.81.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream version (5.81.0)
  * Bump inter-frameworks dependencies.
  * Update symbols.

 -- Norbert Preining <norbert@preining.info>  Mon, 12 Apr 2021 19:03:13 +0900

ktexteditor (5.80.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * Add libkf5syntaxhighlighting-dev to the -dev package deps.
  * New upstream version (5.80.0)
  * Bump inter-frameworks dependencies.
  * Update symbols.

 -- Norbert Preining <norbert@preining.info>  Mon, 15 Mar 2021 15:10:36 +0900

ktexteditor (5.79.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.79.0).
  * Update symbols.

 -- Norbert Preining <norbert@preining.info>  Tue, 16 Feb 2021 06:45:29 +0900
