## ktexteditor 5.98.0

=== debian/changelog ===
ktexteditor (5.98.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release (5.98.0)
  * Update symbols.
  * Update lintian overrides.

 -- Rik Mills <rikmills@kde.org>  Sun, 11 Sep 2022 11:33:41 +0100

ktexteditor (5.97.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release (5.97.0)

 -- Rik Mills <rikmills@kde.org>  Sat, 13 Aug 2022 14:06:02 +0100

ktexteditor (5.96.0-0ubuntu2) kinetic; urgency=medium

  * Update symbols

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Fri, 29 Jul 2022 13:39:43 +0100

ktexteditor (5.96.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release (5.96.0)
  * Update lintian overrides.

 -- Rik Mills <rikmills@kde.org>  Sat, 09 Jul 2022 16:31:43 +0100

ktexteditor (5.95.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release (5.95.0)
  * Update symbols.

 -- Rik Mills <rikmills@kde.org>  Sat, 11 Jun 2022 09:57:30 +0100

ktexteditor (5.94.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release (5.94.0)
  * Update symbols.
  * Disable acc test.

 -- Rik Mills <rikmills@kde.org>  Thu, 12 May 2022 16:21:18 +0100

ktexteditor (5.93.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release (5.93.0)
  * Update symbols.

 -- Rik Mills <rikmills@kde.org>  Fri, 29 Apr 2022 08:24:40 +0100
