=== debian/control ===
--- 
+++ 
@@ -7,20 +7,20 @@
 Build-Depends: cmake (>= 3.16~),
                debhelper-compat (= 13),
                doxygen,
-               extra-cmake-modules (>= 5.92.0~),
+               extra-cmake-modules (>= 5.98.0~),
                libeditorconfig-dev,
                libgit2-dev (>= 0.22.0~),
                libjs-underscore,
-               libkf5archive-dev (>= 5.92.0~),
-               libkf5auth-dev (>= 5.92.0~),
-               libkf5config-dev (>= 5.92.0~),
-               libkf5guiaddons-dev (>= 5.92.0~),
-               libkf5i18n-dev (>= 5.92.0~),
-               libkf5kio-dev (>= 5.92.0~),
-               libkf5parts-dev (>= 5.92.0~),
-               libkf5sonnet-dev (>= 5.92.0~),
-               libkf5syntaxhighlighting-dev (>= 5.92.0~),
-               libkf5textwidgets-dev (>= 5.92.0~),
+               libkf5archive-dev (>= 5.98.0~),
+               libkf5auth-dev (>= 5.98.0~),
+               libkf5config-dev (>= 5.98.0~),
+               libkf5guiaddons-dev (>= 5.98.0~),
+               libkf5i18n-dev (>= 5.98.0~),
+               libkf5kio-dev (>= 5.98.0~),
+               libkf5parts-dev (>= 5.98.0~),
+               libkf5sonnet-dev (>= 5.98.0~),
+               libkf5syntaxhighlighting-dev (>= 5.98.0~),
+               libkf5textwidgets-dev (>= 5.98.0~),
                libqt5sql5-sqlite,
                libqt5xmlpatterns5-dev (>= 5.8.0~),
                pkg-config,
@@ -88,8 +88,8 @@
 Package: libkf5texteditor-dev
 Section: libdevel
 Architecture: any
-Depends: libkf5parts-dev (>= 5.92.0~),
-         libkf5syntaxhighlighting-dev (>= 5.92.0~),
+Depends: libkf5parts-dev (>= 5.98.0~),
+         libkf5syntaxhighlighting-dev (>= 5.98.0~),
          libkf5texteditor5 (= ${binary:Version}),
          qtbase5-dev (>= 5.15.2~),
          ${misc:Depends},
